#ifndef TRACKERGREP_WINDOW_H
#define TRACKERGREP_WINDOW_H

// ***************************************************************************
// System Includes
// ***************************************************************************

// ***************************************************************************
// Project Includes
// ***************************************************************************

#include "StyleGuideDefs.h"          // Standard type and constant definitions

// ***************************************************************************
// External Name Declarations
// ***************************************************************************

// ***************************************************************************
// External Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Constant Definitions
// ***************************************************************************

// ***************************************************************************
// Type Definitions
// ***************************************************************************

// ***************************************************************************
// Class Definition
// ***************************************************************************

/**  
 * The main window.
 */
class tWindow : public BWindow {
public:
  // Constant Definitions ====================================================

  // Type Definitions ========================================================

  // Attribute Definitions ===================================================

  // Member Function Definitions =============================================
 
  // Lifecycle ---------------------------------------------------------------

  // _KMSF_012099_
  /** Constructor. */
  tWindow(entry_ref aDirRef, BMessage* apMessage); 

  /** Automatically generated copy constructor. */
  // tWindow(const tWindow& arOld);

  // _KMSF_012099_
  /** destructor. */
  virtual ~tWindow();

  // Operators ---------------------------------------------------------------

  /** Automatically generated assignment operator. */
  // tWindow& operator=(tWindow& arRight);

  // Operations --------------------------------------------------------------

  /** Handles the messages that the window receives. */
  virtual void MessageReceived(BMessage* apMessage);

  /** Loads the Tracker Grep prefs and lets them loose on this window. */
  void LoadPrefs();
  
  /** Looks at this window's settings and saves them into the prefs file. */
  void SavePrefs();

  /**
   * Responds to a notification that the window's content area has been
   * resized
   */
  virtual void FrameResized(float width, float height);
  
  /** Responds to a notification that the window has moved. */
  virtual void FrameMoved(BPoint screenPoint);

  // Access ------------------------------------------------------------------

  // Inquiry -----------------------------------------------------------------

protected:
  // Constant Definitions ====================================================

  // Type Definitions ========================================================

  // Attribute Definitions ===================================================

  // Member Function Definitions =============================================

private:
  // Constant Definitions ====================================================

  // Type Definitions ========================================================

  // Attribute Definitions ===================================================
  
  /** Pointer to the entry field of the search pattern. */
  BTextControl* mpSearchText;
  
  /** Pointer to the view that will display the results of the search. */
  //BTextView* mpSearchResults;
  BOutlineListView *mpSearchResults;

  /** Pointer to the "subdirectories" check box. */
  BCheckBox* mpRecurseDirs;

  /** Pointer to the "links" check box. */
  BCheckBox* mpRecurseLinks;
  
  /** Pointer to the "show contents" check box. */
  BCheckBox* mpShowContents;
 
  /** Pointer to the "search/cancel" button object. */
  BButton* mpButton;
  
  // _KMSF_012099_
  tGrepper *mpGrepper;
  
  /**
   * The search pattern. This will break if the search pattern is larger
   * than 1024 characters, but that's very unlikely. We need to remember it
   * because during the grepping, the text control's text will be replaced by
   * the name of the file that's currently being grepped. When the grepping
   * finishes, we will need to restore the search pattern.
   */
  tChar mSearchPattern[1024];
  
  // Member Function Definitions =============================================
};

// ***************************************************************************
// Global Variable Declarations
// ***************************************************************************

// ***************************************************************************
// Inline Function Definitions
// ***************************************************************************

// ***************************************************************************
// Helper Function Declarations
// ***************************************************************************

// ***************************************************************************
// Global Function Declarations
// ***************************************************************************

#endif // TRACKERGREP_WINDOW_H
